(* ----------------------------------------------------------------------- *)
UNIT REPORTING_;
(* ----------------------------------------------------------------------- *)

INTERFACE
(* ----------------------------------------------------------------------- *)

USES

  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,

  CONSTANTS_,
  ELEMENTS_;
(* ----------------------------------------------------------------------- *)

TYPE

  TReportForm = Class(TForm)
   (* --- Basic Description ---------------------------------------------- *)
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Button1: TButton;
    Button2: TButton;
   (* -------------------------------------------------------------------- *)
    procedure FormCreate(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
   (* -------------------------------------------------------------------- *)
  private
    { Private declarations }
  public
    { Public declarations }
    Procedure ShowEditBoxes( G: Integer);
  end;

  Reporter = Class
   (* --- Basic Description ---------------------------------------------- *)
                                                                 // Abstract
   (* --- Construction --------------------------------------------------- *)
    Constructor SetUp;
    Destructor  Clear;
   (* --- Handling Operations -------------------------------------------- *)
    Function    Enough: Boolean;                                    Virtual;
    Procedure   Announce( E: Elements);                             Virtual;
   (* -------------------------------------------------------------------- *)
  end;

  Counter = Class(Reporter)
   (* --- Basic Description ---------------------------------------------- *)
    Count : Integer;
   (* --- Construction --------------------------------------------------- *)
    Constructor SetUp;
   (* --- Handling Operations -------------------------------------------- *)
    Procedure Announce( E: Elements);                              Override;
   (* -------------------------------------------------------------------- *)
  end;

  HighLight = Class(Reporter)
   (* --- Basic Description ---------------------------------------------- *)
    C : TColor;
   (* -------------------------------------------------------------------- *)
    Constructor SetUp( MarkColor: TColor);
   (* --- Handling Operations -------------------------------------------- *)
    Procedure   Announce( E: Elements);                            Override;
   (* -------------------------------------------------------------------- *)
  end;
(* ----------------------------------------------------------------------- *)

VAR

  ReportForm : TReportForm;
  NumberIt   : Counter;
  ColorIt    : HighLight;
(* ----------------------------------------------------------------------- *)

IMPLEMENTATION
(* ----------------------------------------------------------------------- *)

{$R *.DFM}

(* ----------------------------------------------------------------------- *)
Constructor Reporter.SetUp;
begin
end;

Destructor Reporter.Clear;
begin
end;

Function Reporter.Enough: Boolean;
begin
  Enough := False;
end;

Procedure Reporter.Announce( E: Elements);
begin
end;
(* ----------------------------------------------------------------------- *)

(* ----------------------------------------------------------------------- *)
Constructor Counter.SetUp;
begin
  Count := 0;
end;

Procedure Counter.Announce( E: Elements);
begin
  If E<>NIL then begin
    Inc(Count);
    E.Number := Count;
    E.Color  := _ReportColor_;
  end;
end;
(* ----------------------------------------------------------------------- *)

(* ----------------------------------------------------------------------- *)
Constructor HighLight.SetUp;
begin
  C := MarkColor;
end;

Procedure HighLight.Announce( E: Elements);
begin
  If E<>NIL then E.Color := C;
end;

procedure TReportForm.ShowEditBoxes( G: Integer);
begin
  Edit1.Visible := False;
  Edit2.Visible := False;
  Edit3.Visible := False;
  Edit4.Visible := False;
  Edit5.Visible := False;
  Edit6.Visible := False;
  Case G of
    1: begin
         Edit1.Visible := True;
       end;
    2: begin
         Edit2.Visible := True;
         Edit3.Visible := True;
       end;
    3: begin
         Edit4.Visible := True;
         Edit5.Visible := True;
         Edit6.Visible := True;
       end;
  end;
end;
(* ----------------------------------------------------------------------- *)

(* ----------------------------------------------------------------------- *)
procedure TReportForm.FormCreate(Sender: TObject);
begin
  ShowEditBoxes(0);
end;

procedure TReportForm.RadioButton1Click(Sender: TObject);
begin
  ShowEditBoxes(1);
end;

procedure TReportForm.RadioButton2Click(Sender: TObject);
begin
  ShowEditBoxes(2);
end;

procedure TReportForm.RadioButton3Click(Sender: TObject);
begin
  ShowEditBoxes(3);
end;

(* ======================================================================= *)

begin
  ColorIt  := HighLight.SetUp( _ReportColor_ );
  NumberIt := Counter.SetUp;
end.
