(* ----------------------------------------------------------------------- *)
UNIT DRAW_;
(* ----------------------------------------------------------------------- *)

INTERFACE
(* ----------------------------------------------------------------------- *)

USES

  SysUtils, WinTypes, Graphics,

  CONSTANTS_;
(* ======================================================================= *)

Function  PlaceOf( x1,y1, x2,y2: Integer): Codes;
Procedure DrawLine( Canvas: TCanvas; x1,y1,x2,y2: Integer; C: TColor);
Procedure DrawFrame( Canvas: TCanvas; x1,y1,x2,y2: Integer; C: TColor );
(* ======================================================================= *)

IMPLEMENTATION
(* ----------------------------------------------------------------------- *)

Function PlaceOf( x1,y1, x2,y2: Integer): Codes;
begin
  Case (x2<=x1) of
    Ok : Case (y2<=y1) of
           Ok : PlaceOf := _UpLf_;
           No : PlaceOf := _DnLf_;
         end;
    No : Case (y2<=y1) of
           Ok : PlaceOf := _UpRt_;
           No : PlaceOf := _DnRt_;
         end;
  end;
end;

Procedure DrawLine( Canvas: TCanvas; x1,y1,x2,y2: Integer; C: TColor);
Var
  dx,dy: Integer;
begin
  With Canvas do begin
    Pen.Width := 1;
    Pen.Color := C;
    dx := Abs(x2-x1);
    dy := Abs(y2-y1);
    Case (Abs(dx)>10) and (Abs(dy)>10) of
      Ok: Case PlaceOf( x1,y1, x2,y2) of
          (* --- Up to Down Links ---------------------------------------- *)
            _DnLf_ : Arc( x2-Dx,y1-Dy, x1,y2,    x2,y2, x1,y1 );
            _DnRt_ : Arc( x1,y1-Dy,    x2+Dx,y2, x1,y1, x2,y2 );
          (* --- Down to Up Links ---------------------------------------- *)
            _UpLf_ : Arc( x2-Dx,y2, x1,y1+Dy,    x1,y1, x2,y2 );
            _UpRt_ : Arc( x1,y2,    x2+Dx,y1+Dy, x2,y2, x1,y1 );
          (* ------------------------------------------------------------- *)
          end;
      No: begin MoveTo(x1,y1); LineTo(x2,y2); end;
    end;
  end;
end;

Procedure DrawFrame( Canvas: TCanvas; x1,y1,x2,y2: Integer; C: TColor );
begin
  With Canvas do begin
    Pen.Width   := 1;
    Pen.Color   := _FrameColor_;
    Brush.Style := bsSolid;
    Brush.Color := C;
    Rectangle( x1, y1, x2, y2);
  end;
end;

(* ======================================================================= *)

begin
end.

